Package: bedrockbio
Title: Open-Access Computational Biology Datasets
Version: 2.0.0
Authors@R: 
    person(
      "Liam", "Abbott", , "liam@bedrock.bio", role = c("aut", "cre", "cph")
    )
Description: Efficiently access the 'Bedrock Bio' library of open-access
    computational biology datasets. Lazily query datasets backed by 'DuckDB'
    and 'Apache Iceberg', with support for predicate pushdown and column
    projection to the cloud storage backend. This enables quick, iterative
    access to otherwise massive, unwieldy datasets without downloading them
    in full. See <https://bedrock.bio> for available datasets and
    documentation.
Language: en-US
License: GPL (>= 3)
URL: https://bedrock.bio,
        https://github.com/bedrock-bio/bedrock-bio-client
BugReports: https://github.com/bedrock-bio/bedrock-bio-client/issues
Depends: R (>= 4.2)
Imports: curl, DBI, dbplyr, dplyr, duckdb, jsonlite
Suggests: testthat (>= 3.0.0), withr
Config/testthat/edition: 3
OS_type: unix
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-07-02 13:03:40 UTC; runner
Author: Liam Abbott [aut, cre, cph]
Maintainer: Liam Abbott <liam@bedrock.bio>
Repository: CRAN
Date/Publication: 2026-07-02 13:20:07 UTC
Built: R 4.5.2; ; 2026-07-02 14:51:05 UTC; unix

# bedrockbio

Open-Access Computational Biology Datasets

## Description

Efficiently access a curated library of open-access computational biology
datasets. Tables support predicate pushdown and projection to the cloud
storage backend, enabling quick, iterative access to otherwise massive,
unwieldy tables.

`bedrockbio` consists of five user-facing functions:

- `list_namespaces()`: returns a character vector of available namespace
  (data source) identifiers
- `describe_namespace("<name>")`: returns a namespace's name, citation,
  license, context, and its tables
- `list_tables(namespace)`: returns a character vector of table identifiers,
  optionally filtered to one namespace
- `describe_table("<name>")`: returns a table's context, column definitions,
  and partition columns (with their allowed values)
- `load_table("<name>")`: returns a lazily-evaluated data frame for a table

`dplyr` verbs (`filter`, `select`) can be used on the data frame returned by
`load_table` to push down row filters and column selections to the storage
backend. Filtering on the partition columns returned by `describe_table`
gives the fastest reads.

## Installation

Install from [CRAN](https://cran.r-project.org/):

```r
install.packages("bedrockbio")
```

Or install the current development version from
[GitHub](https://github.com/bedrock-bio/bedrock-bio-client):

```r
# install.packages("pak")
pak::pak("bedrock-bio/bedrock-bio-client/r")
```

The R package supports macOS and Linux only: the DuckDB `iceberg` extension
has no MinGW build, so it cannot load on R for Windows. Windows users can use
the [Python client](https://pypi.org/project/bedrock-bio/) instead, which works
on all platforms.

## Examples

Load the package (and `dplyr` for downstream data frame manipulation):

```r
library(bedrockbio)
library(dplyr)
```

List available tables:

```r
list_tables()
```

Describe a table to see its metadata, citation, and columns:

```r
describe_table("ukb_ppp.pqtls")
```

Lazily load a table, filter on partition columns (for fastest reads), select
columns, and collect the relevant subset into an in-memory data frame:

```r
df <- load_table("ukb_ppp.pqtls") |>
  filter(
    ancestry == "EUR",
    protein_id == "A0FGR8",
    panel == "Inflammation"
  ) |>
  select(
    chromosome,
    position,
    effect_allele,
    other_allele,
    beta,
    neg_log_10_p_value
  ) |>
  collect()
```

## Dataset Requests

To request the addition of a new table to the library, open an
[issue](https://github.com/bedrock-bio/bedrock-bio-client/issues).

pkg <- new.env(parent = emptyenv())

.onLoad <- function(libname, pkgname) {
  pkg$catalog_url <- "https://data.bedrock.bio/catalog.json"
  pkg$credentials_url <- "https://data.bedrock.bio/credentials.json"
}

.onUnload <- function(libpath) {
  if (!is.null(pkg$conn)) {
    DBI::dbDisconnect(pkg$conn, shutdown = TRUE)
  }
}

#' Lazily query a table
#'
#' @param name Table identifier (e.g., "ukb_ppp.pqtls")
#' @returns A lazy `tbl` backed by DuckDB, compatible with dplyr verbs.
#'   Use `describe_table()` to see partition columns and per-column allowed
#'   values; filter on partition columns for fastest reads.
#'
#' @examples
#' \dontrun{
#' library(bedrockbio)
#' library(dplyr)
#'
#' df <- load_table("dbsnp.vcf") |>
#'   filter(assembly == "GRCh38", chromosome == "22") |>
#'   select(rsid, position, ref_allele, alt_allele) |>
#'   head(5) |>
#'   collect()
#' }
#'
#' @export
load_table <- function(name) {
  catalog <- get_catalog()

  if (!name %in% names(catalog)) {
    stop(
      "Table '", name, "' not found in catalog. ",
      "See list_tables() for available tables.",
      call. = FALSE
    )
  }

  entry <- catalog[[name]]
  conn <- get_connection()
  query <- DBI::sqlInterpolate(
    conn,
    "SELECT * FROM iceberg_scan(?path)",
    path = entry$metadata_json
  )
  dplyr::tbl(conn, dplyr::sql(query))
}

skip_on_cran()
skip_if_offline()

dbsnp <- function() {
  load_table("dbsnp.vcf") |>
    dplyr::filter(assembly == "GRCh38", chromosome == "22")
}

test_that("errors on unknown table", {
  expect_error(
    load_table("not_a_table"),
    "not found in catalog"
  )
})

test_that("returns a lazy tbl", {
  expect_s3_class(load_table("dbsnp.vcf"), "tbl_lazy")
})

test_that("filter narrows results", {
  df <- head(dbsnp(), 5) |> dplyr::collect()
  expect_equal(nrow(df), 5L)
  expect_equal(unique(df$chromosome), "22")
})

test_that("select limits columns", {
  df <- dbsnp() |>
    dplyr::select(chromosome, position) |>
    head(5) |>
    dplyr::collect()
  expect_equal(names(df), c("chromosome", "position"))
})

#' Describe a table's metadata, citation, and columns
#'
#' @param name Table identifier (e.g., "ukb_ppp.pqtls")
#' @returns A named list with name, description, citation, source_url,
#'   license, and columns.
#'
#' @examples
#' \dontrun{
#' library(bedrockbio)
#' info <- describe_table("ukb_ppp.pqtls")
#' info$name
#' }
#'
#' @export
describe_table <- function(name) {
  catalog <- get_catalog()

  if (!name %in% names(catalog)) {
    stop(
      "Table '", name, "' not found in catalog. ",
      "See list_tables() for available tables.",
      call. = FALSE
    )
  }

  entry <- catalog[[name]]
  list(
    name = name,
    description = entry$description,
    citation = entry$citation,
    source_url = entry$source_url,
    license = entry$license,
    columns = entry$columns
  )
}

skip_on_cran()

test_that("errors on unknown table", {
  expect_error(
    describe_table("not_a_table"),
    "not found in catalog"
  )
})

test_that("returns expected fields", {
  result <- describe_table("ukb_ppp.pqtls")
  expect_equal(result$name, "ukb_ppp.pqtls")
  expect_type(result$description, "character")
  expect_true(nzchar(result$description))
  expect_type(result$citation, "list")
  expect_type(result$source_url, "character")
  expect_type(result$license, "character")
  expect_type(result$columns, "list")
  expect_true(length(result$columns) > 0)
})

test_that("columns have expected fields", {
  result <- describe_table("dbsnp.vcf")
  for (col in result$columns) {
    expect_true("name" %in% names(col))
    expect_true("type" %in% names(col))
    expect_true("description" %in% names(col))
  }
})

fetch_json <- function(url) {
  h <- curl::new_handle()
  curl::handle_setheaders(h, "User-Agent" = "bedrock-bio")
  con <- curl::curl(url, handle = h)
  on.exit(close(con))
  readLines(con, warn = FALSE)
}

#' @noRd
get_catalog <- function() {
  if (!is.null(pkg$catalog)) {
    return(pkg$catalog)
  }

  raw <- tryCatch(
    jsonlite::fromJSON(fetch_json(pkg$catalog_url), simplifyDataFrame = FALSE),
    error = function(e) {
      stop(
        "Unable to access manifest URL '", pkg$catalog_url, "'. ",
        "Check internet connection and try again.",
        call. = FALSE
      )
    }
  )

  entries <- list()
  for (ns in names(raw$namespaces)) {
    tables <- raw$namespaces[[ns]]$tables
    for (table_name in names(tables)) {
      meta <- tables[[table_name]]
      partition_by <- meta$partition_by
      if (is.null(partition_by)) partition_by <- character(0)
      sort_by <- meta$sort_by
      if (is.null(sort_by)) sort_by <- character(0)

      keep <- c(
        "name", "type", "description",
        "nullable", "allowed_values"
      )
      columns <- lapply(meta$columns, function(col) {
        col[intersect(names(col), keep)]
      })

      ns_data <- raw$namespaces[[ns]]
      entries[[paste0(ns, ".", table_name)]] <- list(
        metadata_json = meta$metadata_json,
        partition_by = as.character(partition_by),
        sort_by = as.character(sort_by),
        description = meta$description,
        citation = ns_data$citation,
        source_url = ns_data$source_url,
        license = ns_data$license,
        columns = columns
      )
    }
  }
  pkg$catalog <- entries
  pkg$catalog
}

#' @noRd
get_credentials <- function() {
  if (!is.null(pkg$credentials)) {
    return(pkg$credentials)
  }

  pkg$credentials <- tryCatch(
    jsonlite::fromJSON(fetch_json(pkg$credentials_url)),
    error = function(e) {
      stop(
        "Unable to fetch credentials from '", pkg$credentials_url, "'. ",
        "Check internet connection and try again.",
        call. = FALSE
      )
    }
  )
  pkg$credentials
}

#' @noRd
get_connection <- function() {
  if (!is.null(pkg$conn)) {
    return(pkg$conn)
  }

  credentials <- get_credentials()
  pkg$conn <- DBI::dbConnect(duckdb::duckdb())
  DBI::dbExecute(pkg$conn, "INSTALL httpfs")
  DBI::dbExecute(pkg$conn, "INSTALL iceberg")

  DBI::dbExecute(
    pkg$conn,
    "CREATE SECRET (TYPE s3, KEY_ID ?, SECRET ?, ENDPOINT ?, URL_STYLE 'path')",
    params = list(
      credentials$BB_R2_ACCESS_KEY_ID,
      credentials$BB_R2_SECRET_ACCESS_KEY,
      paste0(credentials$BB_R2_ACCOUNT_ID, ".r2.cloudflarestorage.com")
    )
  )

  pkg$conn
}

reset_pkg <- function() {
  pkg <- bedrockbio:::pkg
  pkg$catalog <- NULL
  pkg$credentials <- NULL
  if (!is.null(pkg$conn)) {
    try(DBI::dbDisconnect(pkg$conn, shutdown = TRUE), silent = TRUE)
  }
  pkg$conn <- NULL
}

# --- get_catalog ---

test_that("get_catalog returns a named list of entry lists", {
  skip_on_cran()
  skip_if_offline()
  reset_pkg()
  result <- bedrockbio:::get_catalog()
  expect_type(result, "list")
  expect_true(length(result) > 0)
  for (entry in result) {
    expect_type(entry, "list")
    expect_type(entry$metadata_json, "character")
    expect_type(entry$partition_by, "character")
    expect_type(entry$sort_by, "character")
    expect_type(entry$columns, "list")
  }
})

test_that("get_catalog caches result", {
  skip_on_cran()
  skip_if_offline()
  reset_pkg()
  first <- bedrockbio:::get_catalog()
  second <- bedrockbio:::get_catalog()
  expect_identical(first, second)
})

test_that("get_catalog errors when URL is unreachable", {
  reset_pkg()
  pkg <- bedrockbio:::pkg
  original_url <- pkg$catalog_url
  pkg$catalog_url <- "https://invalid.invalid/manifest.json"
  on.exit({
    pkg$catalog_url <- original_url
    reset_pkg()
  })
  expect_error(
    suppressWarnings(bedrockbio:::get_catalog()),
    "Unable to access manifest URL"
  )
})

test_that("get_catalog preserves whitelisted column keys and strips others", {
  reset_pkg()
  fixture <- tempfile(fileext = ".json")
  jsonlite::write_json(
    list(
      namespaces = list(
        test_ns = list(
          citation = list(),
          source_url = "https://example.com",
          license = "MIT",
          tables = list(
            test_tbl = list(
              metadata_json = "s3://test/metadata.json",
              description = "test",
              partition_by = list(),
              sort_by = list(),
              columns = list(
                list(
                  name = "col_with_extras",
                  type = "string",
                  description = "desc",
                  nullable = TRUE,
                  allowed_values = list("A", "B"),
                  extra_field = "should_be_stripped",
                  another_extra = 123
                ),
                list(
                  name = "col_minimal",
                  type = "int",
                  description = "minimal"
                )
              )
            )
          )
        )
      )
    ),
    fixture,
    auto_unbox = TRUE
  )

  pkg <- bedrockbio:::pkg
  original_url <- pkg$catalog_url
  pkg$catalog_url <- paste0("file://", fixture)
  on.exit({
    pkg$catalog_url <- original_url
    unlink(fixture)
    reset_pkg()
  })

  result <- bedrockbio:::get_catalog()
  cols <- result[["test_ns.test_tbl"]]$columns

  c1 <- cols[[1]]
  expect_equal(c1$name, "col_with_extras")
  expect_equal(c1$type, "string")
  expect_equal(c1$description, "desc")
  expect_true(c1$nullable)
  expect_equal(c1$allowed_values, c("A", "B"))
  expect_false("extra_field" %in% names(c1))
  expect_false("another_extra" %in% names(c1))

  c2 <- cols[[2]]
  expect_equal(c2$name, "col_minimal")
  expect_false("nullable" %in% names(c2))
  expect_false("allowed_values" %in% names(c2))
})

# --- get_credentials ---

test_that("get_credentials returns expected keys", {
  skip_on_cran()
  skip_if_offline()
  reset_pkg()
  result <- bedrockbio:::get_credentials()
  expected_names <- c(
    "BB_R2_ACCOUNT_ID",
    "BB_R2_ACCESS_KEY_ID",
    "BB_R2_SECRET_ACCESS_KEY"
  )
  expect_true(all(expected_names %in% names(result)))
  for (nm in expected_names) {
    expect_type(result[[nm]], "character")
    expect_true(nzchar(result[[nm]]))
  }
})

test_that("get_credentials caches result", {
  skip_on_cran()
  skip_if_offline()
  reset_pkg()
  first <- bedrockbio:::get_credentials()
  second <- bedrockbio:::get_credentials()
  expect_identical(first, second)
})

test_that("get_credentials errors when URL is unreachable", {
  reset_pkg()
  pkg <- bedrockbio:::pkg
  original_url <- pkg$credentials_url
  pkg$credentials_url <- "https://invalid.invalid/credentials.json"
  on.exit({
    pkg$credentials_url <- original_url
    reset_pkg()
  })
  expect_error(
    suppressWarnings(bedrockbio:::get_credentials()),
    "Unable to fetch credentials"
  )
})

# --- get_connection ---

test_that("get_connection returns DuckDB with S3 secret", {
  skip_on_cran()
  skip_if_offline()
  reset_pkg()
  conn <- bedrockbio:::get_connection()
  expect_s4_class(conn, "duckdb_connection")
  secrets <- DBI::dbGetQuery(conn, "FROM duckdb_secrets()")
  expect_equal(nrow(secrets), 1L)
  expect_equal(secrets$type, "s3")
  expect_true(grepl("r2.cloudflarestorage.com", secrets$secret_string))
})

test_that("get_connection caches", {
  skip_on_cran()
  skip_if_offline()
  reset_pkg()
  first <- bedrockbio:::get_connection()
  second <- bedrockbio:::get_connection()
  expect_identical(first, second)
})

test_that("reset clears cached catalog, credentials, and conn", {
  skip_on_cran()
  skip_if_offline()
  bedrockbio:::get_catalog()
  bedrockbio:::get_credentials()
  bedrockbio:::get_connection()
  pkg <- bedrockbio:::pkg
  expect_false(is.null(pkg$catalog))
  expect_false(is.null(pkg$credentials))
  expect_false(is.null(pkg$conn))
  reset_pkg()
  expect_null(pkg$catalog)
  expect_null(pkg$credentials)
  expect_null(pkg$conn)
})

#' List available tables in the Bedrock Bio library
#'
#' @returns A character vector of table identifiers
#'
#' @examples
#' \dontrun{
#' library(bedrockbio)
#' list_tables()
#' }
#'
#' @export
list_tables <- function() {
  catalog <- get_catalog()
  names(catalog)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list_tables.R
\name{list_tables}
\alias{list_tables}
\title{List available tables in the Bedrock Bio library}
\usage{
list_tables()
}
\value{
A character vector of table identifiers
}
\description{
List available tables in the Bedrock Bio library
}
\examples{
\dontrun{
library(bedrockbio)
list_tables()
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bedrockbio-package.R
\docType{package}
\name{bedrockbio-package}
\alias{bedrockbio}
\alias{bedrockbio-package}
\title{bedrockbio: Open-Access Computational Biology Datasets}
\description{
Efficiently access the 'Bedrock Bio' library of open-access computational biology datasets. Lazily query datasets backed by 'DuckDB' and 'Apache Iceberg', with support for predicate pushdown and column projection to the cloud storage backend. This enables quick, iterative access to otherwise massive, unwieldy datasets without downloading them in full. See \url{https://bedrock.bio} for available datasets and documentation.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://bedrock.bio}
  \item \url{https://github.com/bedrock-bio/bedrock-bio-client}
  \item Report bugs at \url{https://github.com/bedrock-bio/bedrock-bio-client/issues}
}

}
\author{
\strong{Maintainer}: Liam Abbott \email{liam@bedrock.bio} [copyright holder]

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/describe_table.R
\name{describe_table}
\alias{describe_table}
\title{Describe a table's metadata, citation, and columns}
\usage{
describe_table(name)
}
\arguments{
\item{name}{Table identifier (e.g., "ukb_ppp.pqtls")}
}
\value{
A named list with name, description, citation, source_url,
license, and columns.
}
\description{
Describe a table's metadata, citation, and columns
}
\examples{
\dontrun{
library(bedrockbio)
info <- describe_table("ukb_ppp.pqtls")
info$name
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_table.R
\name{load_table}
\alias{load_table}
\title{Lazily query a table}
\usage{
load_table(name, ...)
}
\arguments{
\item{name}{Table identifier (e.g., "ukb_ppp.pqtls")}

\item{...}{Required partition filters
(e.g., ancestry = "EUR", protein_id = "A0FGR8")}
}
\value{
A lazy \code{tbl} backed by DuckDB, compatible with dplyr verbs.
}
\description{
Lazily query a table
}
\examples{
\dontrun{
library(bedrockbio)
library(dplyr)

df <- load_table(
  "dbsnp.vcf",
  assembly = "GRCh38",
  chromosome = "22"
) |>
  select(rsid, position, ref_allele, alt_allele) |>
  head(5) |>
  collect()
}

}
